﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Web.Services.Protocols;
using System.Collections;
using System.IO;
using Node.Core2.Requestor;
using Node.Core.Util;

namespace EN_NodeSampleCode
{
    public partial class Form1 : Form
    {
        NodeRequestor req = null;
        public Form1()
        {
            InitializeComponent();

            req = new NodeRequestor(txtUrl.Text);
            req.RequireMtom = true;

            //PROXY
            if (grpProxy.Visible == true)
            {
                System.Net.NetworkCredential cred = new System.Net.NetworkCredential(txtProxyUser.Text, txtProxyPwd.Text);
                System.Net.WebProxy proxy = new System.Net.WebProxy(txtProxyAddy.Text, true, null, cred);
                req.Proxy = proxy;
            }
        }

        private void btnAuthentication_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            Authenticate auth = new Authenticate();
            auth.userId = this.txtUserId2.Text;
            auth.credential = this.txtPassword2.Text;
            auth.authenticationMethod = this.txtAuthenticationMethod2.Text.ToUpper();
            auth.domain = this.txtDomain.Text;
            try
            {
                Node.Core2.Requestor.AuthenticateResponse resp = req.Authenticate(auth);
                this.txtToken.Text = resp.securityToken;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            Cursor.Current = Cursors.Default;
        }

        private void chkProxy_CheckedChanged(object sender, EventArgs e)
        {
            if (chkProxy.Checked == true)
                grpProxy.Visible = true;
            else
                grpProxy.Visible = false;
        }

        private void btnQueue_Click(object sender, EventArgs e)
        {

            Cursor.Current = Cursors.WaitCursor;

            Query qry = new Node.Core2.Requestor.Query();
            qry.dataflow = "";
            qry.request = txtRequest.Text;
            qry.securityToken = this.txtToken.Text;
            qry.rowId = "0";
            qry.maxRows = "-1";

            ParameterType[] parameters = new ParameterType[6];

            parameters[0] = new Node.Core2.Requestor.ParameterType();
            parameters[0].parameterName = lblPara1.Text;
            parameters[0].Value = txtPara1.Text;

            parameters[1] = new Node.Core2.Requestor.ParameterType();
            parameters[1].parameterName = lblPara2.Text;
            parameters[1].Value = txtPara2.Text;

            parameters[2] = new Node.Core2.Requestor.ParameterType();
            parameters[2].parameterName = lblPara3.Text;
            parameters[2].Value = txtPara3.Text;

            parameters[3] = new Node.Core2.Requestor.ParameterType();
            parameters[3].parameterName = lblPara4.Text;
            parameters[3].Value = txtPara4.Text;

            parameters[4] = new Node.Core2.Requestor.ParameterType();
            parameters[4].parameterName = lblPara5.Text;
            parameters[4].Value = txtPara5.Text;

            parameters[5] = new Node.Core2.Requestor.ParameterType();
            parameters[5].parameterName = lblPara6.Text;
            parameters[5].Value = txtPara6.Text;

            qry.parameters = parameters;

            try
            {
                Node.Core2.Requestor.ResultSetType result = req.Query(qry);

                if (NodeXMLResult.isValidXMLContent(result.results.Any[0].OuterXml))
                    lblResult.Text = NodeXMLResult.GetWellFormatXML(result.results.Any[0].OuterXml);
                else
                    lblResult.Text = result.results.Any[0].OuterXml;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            Cursor.Current = Cursors.Default;
        }

        private void btnSolicit_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            Solicit sol = new Solicit();
            sol.securityToken = this.txtToken.Text;
            sol.dataflow = "";
            sol.request = txtRequest.Text;
            sol.recipient = new string[1];
            sol.notificationURI = new Node.Core2.Requestor.NotificationURIType[1];
            sol.notificationURI[0] = new Node.Core2.Requestor.NotificationURIType();
            sol.notificationURI[0].notificationType = NotificationTypeCode.Warning;
            sol.notificationURI[0].Value = "";

            Node.Core2.Requestor.NotificationURIType[] notifyURI = new Node.Core2.Requestor.NotificationURIType[1];
            notifyURI[0] = new Node.Core2.Requestor.NotificationURIType();
            sol.notificationURI = notifyURI;
            sol.notificationURI[0].Value = "";

            ParameterType[] parameters = new ParameterType[6];

            parameters[0] = new Node.Core2.Requestor.ParameterType();
            parameters[0].parameterName = lblPara1.Text;
            parameters[0].Value = txtPara1.Text;

            parameters[1] = new Node.Core2.Requestor.ParameterType();
            parameters[1].parameterName = lblPara2.Text;
            parameters[1].Value = txtPara2.Text;

            parameters[2] = new Node.Core2.Requestor.ParameterType();
            parameters[2].parameterName = lblPara3.Text;
            parameters[2].Value = txtPara3.Text;

            parameters[3] = new Node.Core2.Requestor.ParameterType();
            parameters[3].parameterName = lblPara4.Text;
            parameters[3].Value = txtPara4.Text;

            parameters[4] = new Node.Core2.Requestor.ParameterType();
            parameters[4].parameterName = lblPara5.Text;
            parameters[4].Value = txtPara5.Text;

            parameters[5] = new Node.Core2.Requestor.ParameterType();
            parameters[5].parameterName = lblPara6.Text;
            parameters[5].Value = txtPara6.Text;

            sol.parameters = parameters;

            try
            {

                Node.Core2.Requestor.StatusResponseType resp = req.Solicit(sol);

                txtTransationID.Text = resp.transactionId;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            Cursor.Current = Cursors.Default;
        }

        private void btnGetStatus_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            GetStatus getsts = new GetStatus();
            getsts.securityToken = txtToken.Text;
            getsts.transactionId = txtTransationID.Text;

            try
            {
                StatusResponseType resp = req.GetStatus(getsts);

                if (resp.status.ToString().ToUpper() == "COMPLETED")
                {
                    MessageBox.Show("File is ready to download.");
                    btnDownload.Enabled = true;
                }
                else
                {
                    MessageBox.Show("File is not ready yet.");
                    btnDownload.Enabled = false;
                }; 
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);            
            }

            Cursor.Current = Cursors.Default;
        }

        private void btnDownload_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            Node.Core2.Requestor.Download download = new Node.Core2.Requestor.Download();
            download.transactionId = txtTransationID.Text;
            download.securityToken = txtToken.Text;
            Node.Core2.Requestor.NodeDocumentType[] retDocs = new Node.Core2.Requestor.NodeDocumentType[0];
            download.documents = retDocs;
            try
            {
                retDocs = req.Download(download);
                NodeDocumentType doc = retDocs[0];

                FolderBrowserDialog dialog = new FolderBrowserDialog();
                dialog.ShowDialog();
                string sSavedFileName = dialog.SelectedPath +@"\"+ doc.documentName;

                System.IO.FileStream w = new System.IO.FileStream(sSavedFileName, System.IO.FileMode.OpenOrCreate);
                w.Write(doc.documentContent.Value,0,doc.documentContent.Value.Length);
                w.Close();

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            Cursor.Current = Cursors.Default;
        }

    }
}
